# Puppet Module for Splunk Universal Forwarder

## Splunk Forwarder Deployment

- Splunk Universal Forwarder

## Setup Requirements

[**Splunk Universal Forwarder**](https://www.spunk.com)

[**Puppet Enterprise 2017.1.1+**](https://www.puppet.com)

## Deployment Prerequisites

Due to export compliance rules we can not offer Splunk Binary via any upstream providers or repos without any validation.
Please goto www.splunk.com, sign in with your account and download the Splunk Binary for your preferred environment
and create a simple web server (Apache, Nginx or Lighttpd) that will host the binary and allow directory listing for Apt-Get, Yum or
Windows to detect the desired packages.

In your site.pp you will need to specify the repo so puppet can utilize the package manager to install Splunk or Universal Forwarder.

CentOS or RedHat Example:

```
yumrepo { "splunk":
  baseurl => "http://privaterepo.local/",
  descr => "Splunk Private Repo",
  enabled => 1,
  gpgcheck => 0
}
```

Ubuntu Example:

```
file { "/etc/apt/apt.conf.d/99allowunsigned":
  ensure => present,
  content => "APT::Get::AllowUnauthenticated "true";\n",
}
file { "/etc/apt/sources.list.d/splunk.list":
  ensure => present,
  content => "deb http://privaterepo.local/ ./\n",
}
```

## Getting Started with Puppet Module

```
node 'monitoring.splunkcloud.com' {
  class { 'splunkuniversalforwarder':
    type => 'uf',
    ds   => 'singleinstance.splunkcloud.com:8089',
  }
}
```


Support
-------

Are you a Splunk + Puppet customer who enjoys sharing knowledge and want to put some great feature into an opensource project. We encourage you to submit issues and pull request so that we can make this Puppet Module better and help the community as a whole.

Feel free to leave comments or questions. We are here to make this community project more adaptive to all types of use cases.
